package org.bitbucket.bradleysmithllc.etlunit.feature;

import java.util.ArrayList;
import java.util.List;

public class FeatureProxyBase<K>
{
	interface Getter<K>
	{
		K get(Feature f);
	}

	private final Getter<K> getter;
	private final List<Feature> list;

	private final List<K> klist = new ArrayList<K>();

	private int lastSize = -1;

	public FeatureProxyBase(List<Feature> list, Getter<K> getter)
	{
		this.list = list;
		this.getter = getter;
	}

	public List<K> getList()
	{
		if (list.size() == lastSize)
		{
			return klist;
		}

		klist.clear();

		for (Feature feature : list)
		{
			K k = getter.get(feature);

			if (k != null)
			{
				klist.add(k);
			}
		}

		lastSize = list.size();

		return klist;
	}
}