package org.bitbucket.bradleysmithllc.etlunit.io.file;

import java.util.HashMap;
import java.util.Map;

public interface SupportedColumnTypes
{
	public String INTEGER = "INTEGER";
	public DataFormatValidator INTEGER_VALIDATOR = new PatternValidator(INTEGER, ".*");

	public String BIGINT = "BIGINT";
	public DataFormatValidator BIGINT_VALIDATOR = new PatternValidator(BIGINT, ".*");

	public String SMALLINT = "SMALLINT";
	public DataFormatValidator SMALLINT_VALIDATOR = new PatternValidator(SMALLINT, ".*");

	public String TINYINT = "TINYINT";
	public DataFormatValidator TINYINT_VALIDATOR = new PatternValidator(TINYINT, ".*");

	public String VARCHAR = "VARCHAR";
	public DataFormatValidator VARCHAR_VALIDATOR = new PatternValidator(VARCHAR, ".*");

	public String CHAR = "CHAR";
	public DataFormatValidator CHAR_VALIDATOR = new PatternValidator(CHAR, ".*");

	public String LONGNVARCHAR = "LONGNVARCHAR";
	public DataFormatValidator LONGNVARCHAR_VALIDATOR = new PatternValidator(LONGNVARCHAR, ".*");

	public String TIME = "TIME";
	public DataFormatValidator TIME_VALIDATOR = new PatternValidator(TIME, ".*");

	public String DATE = "DATE";
	public DataFormatValidator DATE_VALIDATOR = new PatternValidator(DATE, ".*");

	public String TIMESTAMP = "TIMESTAMP";
	public DataFormatValidator TIMESTAMP_VALIDATOR = new PatternValidator(TIMESTAMP, ".*");

	public String DECIMAL = "DECIMAL";
	public DataFormatValidator DECIMAL_VALIDATOR = new PatternValidator(DECIMAL, ".*");

	public String NUMERIC = "NUMERIC";
	public DataFormatValidator NUMERIC_VALIDATOR = new PatternValidator(NUMERIC, ".*");

	public String FLOAT = "FLOAT";
	public DataFormatValidator FLOAT_VALIDATOR = new PatternValidator(FLOAT, ".*");

	public String REAL = "REAL";
	public DataFormatValidator REAL_VALIDATOR = new PatternValidator(REAL, ".*");

	public String DOUBLE = "DOUBLE";
	public DataFormatValidator DOUBLE_VALIDATOR = new PatternValidator(DOUBLE, ".*");

	public String BIT = "BIT";
	public DataFormatValidator BIT_VALIDATOR = new PatternValidator(BIT, ".*");

	public String BOOLEAN = "BOOLEAN";
	public DataFormatValidator BOOLEAN_VALIDATOR = new PatternValidator(BOOLEAN, ".*");

	public String CLOB = "CLOB";
	public DataFormatValidator CLOB_VALIDATOR = new PatternValidator(CLOB, ".*");

	public Map<String, DataFormatValidator> TYPES_MAP = new HashMap<String, DataFormatValidator>();

	public Initializer initializer = new Initializer();

	final class Initializer
	{
		static
		{
			TYPES_MAP.put(INTEGER, INTEGER_VALIDATOR);
			TYPES_MAP.put(BIGINT, BIGINT_VALIDATOR);
			TYPES_MAP.put(SMALLINT, TINYINT_VALIDATOR);
			TYPES_MAP.put(TINYINT, INTEGER_VALIDATOR);
			TYPES_MAP.put(VARCHAR, VARCHAR_VALIDATOR);
			TYPES_MAP.put(CHAR, CHAR_VALIDATOR);
			TYPES_MAP.put(LONGNVARCHAR, LONGNVARCHAR_VALIDATOR);
			TYPES_MAP.put(TIME, TIME_VALIDATOR);
			TYPES_MAP.put(DATE, DATE_VALIDATOR);
			TYPES_MAP.put(TIMESTAMP, TIMESTAMP_VALIDATOR);
			TYPES_MAP.put(DECIMAL, DECIMAL_VALIDATOR);
			TYPES_MAP.put(NUMERIC, NUMERIC_VALIDATOR);
			TYPES_MAP.put(FLOAT, FLOAT_VALIDATOR);
			TYPES_MAP.put(REAL, REAL_VALIDATOR);
			TYPES_MAP.put(DOUBLE, DOUBLE_VALIDATOR);
			TYPES_MAP.put(BIT, BIT_VALIDATOR);
			TYPES_MAP.put(BOOLEAN, BOOLEAN_VALIDATOR);
			TYPES_MAP.put(CLOB, CLOB_VALIDATOR);
		}
	}
}