package org.bitbucket.bradleysmithllc.etlunit.parser;

public class ETLTestDebugTraceableImpl implements ETLTestDebugTraceable
{
	protected final Token token;

	public ETLTestDebugTraceableImpl(Token token)
	{
		this.token = token;
	}

	public ETLTestDebugTraceableImpl()
	{
		this(null);
	}

	@Override
	public String getDeclaration()
	{
		if (token != null)
		{
			return token.image;
		}
		else
		{
			return null;
		}
	}

	@Override
	public int getBeginLineNumber()
	{
		if (token != null)
		{
			return token.beginLine;
		}
		else
		{
			return -1;
		}
	}

	@Override
	public int getBeginColumnOffset()
	{
		if (token != null)
		{
			return token.beginColumn;
		}
		else
		{
			return -1;
		}
	}

	@Override
	public int getEndLineNumber()
	{
		if (token != null)
		{
			return token.endLine;
		}
		else
		{
			return -1;
		}
	}

	@Override
	public int getEndColumnOffset()
	{
		if (token != null)
		{
			return token.endColumn;
		}
		else
		{
			return -1;
		}
	}
}